/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 */
package jspritemaker.controller;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.InputEvent;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;

import jspritemaker.view.SpriteManager;
import jspritemaker.view.SpriteView;

/**
 * JSpriteMaker 68k
 * Version 1.0
 * Copyright (C) 2002 John David Ratliff
 */
public class CodePaneInput implements MouseListener, ActionListener {
	private SpriteManager view;
	private JPopupMenu popup;
	
	/* constructors */
	
	public CodePaneInput(SpriteManager view) {
		this.view = view;
		
		this.initPopup();
	}
	
	/* private methods */
	
	private void initPopup() {
		JMenuItem mCopy;
		
		this.popup = new JPopupMenu();
		
		mCopy = new JMenuItem("Copy to Clipboard",KeyEvent.VK_C);
		mCopy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,ActionEvent.CTRL_MASK));
		mCopy.addActionListener(this);
			
		popup.add(mCopy);
	}
	
	private void doPopup(MouseEvent e) {
		if (e.isPopupTrigger()) {
			popup.show(e.getComponent(),e.getX(),e.getY());
		}
	}
	
	/* event listeners */
	
	// action listener
	public void actionPerformed(ActionEvent e) {
		SpriteView sprite = view.getCurrentSprite();
		
		sprite.copy();
	}
	
	// mouse listener
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	
	public void mousePressed(MouseEvent e) {
		doPopup(e);
	}
	
	public void mouseReleased(MouseEvent e) {
		doPopup(e);
	}	
}
