/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 */
package jspritemaker.controller;

import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputListener;

import jspritemaker.view.ColorChooser;
import jspritemaker.view.SpriteManager;
import jspritemaker.view.SpriteView;

/**
 * JSpriteMaker 68k
 * Version 1.0
 * Copyright (C) 2002 John David Ratliff
 */
public class ColorChooserInput implements MouseListener, MouseInputListener {
	private SpriteManager view;
	
	/* constructors */
	
	public ColorChooserInput(SpriteManager view) {
		this.view = view;
	}
	
	/* private methods */
	
	private int whichColor(int x) {
		return (int)(Math.floor(x / (ColorChooser.CC_WIDTH / ColorChooser.COLORS)));
	}
	
	/* event listeners */
	
	// mouse listener
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	
	public void mousePressed(MouseEvent e) {
		SpriteView view = this.view.getCurrentSprite();
		int x = e.getX();
		
		view.setColor(this.whichColor(x));
	}
	
	// mouse motion listener
	public void mouseMoved(MouseEvent e) {}
	
	public void mouseDragged(MouseEvent e) {
		SpriteView view = this.view.getCurrentSprite();
		int x = e.getX();
		
		view.setColor(this.whichColor(x));
	}

}
