/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
 */
package jspritemaker.view;

import java.awt.Dimension;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import javax.swing.JSlider;

/**
 * JSpriteMaker 68k
 * Version 1.0
 * Copyright (C) 2002 John David Ratliff
 */
public class ZoomControl extends JSlider implements ChangeListener {
	private SpriteView owner;
	private JSlider slider;
	
	/* constructors */
	
	protected ZoomControl(SpriteView owner) {
		super(JSlider.HORIZONTAL,(SpriteView.MIN_ZOOM - 1),SpriteView.MAX_ZOOM,owner.getZoom());
		
		this.owner = owner;
		
		// initialize the panel
		this.initSlider();
	}
	
	/* private methods */
	
	private void initSlider() {
		this.setMinorTickSpacing(2);
		this.setMajorTickSpacing(10);
		this.setPaintTicks(true);
		this.setPaintLabels(true);
		
		// add event listeners
		this.addChangeListener(this);
	}
	
	/* public methods */
	
	public Dimension getPreferredSize() {
		return new Dimension(250,50);
	}
	
	/* event listeners */
	
	// change listener
	public void stateChanged(ChangeEvent e) {
		// make sure we're not still sliding
		if (!this.getValueIsAdjusting()) {
			owner.changeZoom(getValue());
		}
	}
}
